from .tokencost.constants import TOKEN_COSTS
from .tokencost import calculate_cost_by_tokens

# update
TOKEN_COSTS.update(
    {
        "ark-deepseek-v3": {
            "max_tokens": 4096,
            "max_input_tokens": 128000,
            "max_output_tokens": 4096,
            "input_cost_per_token": 0.0000010,
            "input_cost_per_token_cache_hit": 1.4e-08,
            "output_cost_per_token": 0.0000040,
            "litellm_provider": "deepseek",
            "mode": "chat",
            "supports_function_calling": True,
            "supports_assistant_prefill": True,
            "supports_tool_choice": True,
            "supports_prompt_caching": True,
        },
        "ark-deepseek-r1": {
            "input_cost_per_token": 0.0000020,
            "output_cost_per_token": 0.0000080,
        },
        "qwen-max": {
            "input_cost_per_token": 0.0000024,
            "output_cost_per_token": 0.0000096,
        },
    }
)


def calculate_cost(usage: dict, model: str) -> float:
    return float(
        calculate_cost_by_tokens(usage["prompt_tokens"], model, "input")
        + calculate_cost_by_tokens(
            usage["completion_tokens"], model, "output"
        )
    )
