from typing import Dict

from docx.shared import RGBColor


def score_to_highlight(score: Dict[str, float], threshold: int) -> RGBColor:
    # green
    # if score["Accuracy"] >= 4 and score["Fluency"] >= 4 and score["Completeness"] >= 4 and score["Style & Word Choice"] >= 4 and sum(score.values()) >= 17:
    #     return RGBColor(0, 255, 0)
    if (
        sum(score.values()) >= threshold
        and score["Accuracy"] >= 4
        and score["Fluency"] >= 4
        and score["Completeness"] >= 4
        and score["Style & Word Choice"] >= 4
    ):
        return RGBColor(0, 255, 0)
    # red
    elif (
        score["Accuracy"] <= 3
        or score["Fluency"] <= 3
        or score["Completeness"] <= 3
        or score["Style & Word Choice"] <= 3
        or sum(score.values()) <= 15
    ):
        return RGBColor(255, 0, 0)
    # yellow
    else:
        return RGBColor(255, 255, 0)


def get_highlight_colors(cache: dict, threshold: int) -> dict:
    return {id: score_to_highlight(cache[id]["score"], threshold) for id in cache}
